/******************************************************************************/
/*                  S A S   S A M P L E   L I B R A R Y                       */
/*                                                                            */
/*    NAME: fcf_update_display_data.sas                                       */
/*   TITLE: fcf_update_display_data                                           */
/* PRODUCT: SAS Anti-Money Laundering                                         */
/*  SYSTEM: UNIX/WINDOWS                                                      */
/******************************************************************************/

/* ************************************************************************** */
/*  Copyright (c) 2014-2016 by SAS Institute Inc., Cary, NC 27513 USA         */
/*  ---All Rights Reserved.                                                   */
/* ************************************************************************** */
%macro fcf_update_display_data (tabLib=WORK,
                                tabName=,
                                LULIB=WORK,
                                LUTAB=,
                                existCol=,
                                LUKey=,
                                LUVal=);

   %local maxKeyLength;
   %local maxValLength;

    proc sql noprint;
     select put(max(length(trim(left(&LUKey)))), best32.) into :maxKeyLength 
       from &LULIB..&LUTAB;
       select put(max(length(trim(left(&LUVal)))), best32.) into :maxValLength 
       from &LULIB..&LUTAB;
    quit;

     data &LULib..&LUTAB (drop=ORG_&LUKey ORG_&LUVal);
     set &LULib..&LUTAB (rename=(&LUKey = ORG_&LUKey &LUVal = ORG_&LUVAL));
      length &LUKey $%trim(%left(&maxKeyLength))
             &LUVal $%trim(%left(&maxValLength));
      &LUKey = trim(left(ORG_&LUKey));
      &LUVAL = trim(left(ORG_&LUVal));
     run;

    data &tabLib..&tabName (drop=&LUKey &LUVal rc);
    set &tabLib..&tabName (rename=(&existCol = &LUKey));
    length &existCol $%trim(%left(&maxValLength));
    if _n_ = 1 then do;
       if 0 then set &LULIB..&LUTAB;
       declare hash COLMAP(dataset:"&LULIB..&LUTAB");
       COLMAP.definekey("&LUKey");
       COLMAP.definedata("&LUKey","&LUVal");
       COLMAP.definedone();
    /* declare hitter retieve('data'); */
     END;
    rc = COLMAP.find();
    if rc = 0 then do;
       &existCol = trim(left(&LUVal));
    END;
    else do;
       PUT 'ERROR NO VALUE FOUND FOR' &LUVal;
     END; 
    run;

%mend fcf_update_display_data;
