--Updated with HF7 changes
ALTER TABLE FCFKC.FSK_RC_FORM_CONFIG
      ADD  IMPLEMENTATION_TYPE_CODE VARCHAR(32) NULL ;


DROP VIEW FCFBU1.FSK_CDD_RULE CASCADE CONSTRAINTS;

DROP VIEW FCFBU1.FSK_CDD_RULE_PARAMETER CASCADE CONSTRAINTS;

DROP VIEW FCFBU1.FSK_CDD_RULE_GROUP CASCADE CONSTRAINTS;

DROP VIEW FCFBU1.FSK_CDD_SCORING_EVENT CASCADE CONSTRAINTS;

DROP TABLE FCFKC.FSK_CDD_RULE_PARAMETER CASCADE CONSTRAINTS PURGE;

DROP TABLE FCFKC.FSK_CDD_RULE CASCADE CONSTRAINTS PURGE;

DROP TABLE FCFKC.FSK_CDD_RULE_GROUP CASCADE CONSTRAINTS PURGE;

DROP TABLE FCFKC.FSK_CDD_SCORING_EVENT CASCADE CONSTRAINTS PURGE;

CREATE TABLE FCFKC.FSK_CDD_RULE
(
	cdd_rule_id          VARCHAR2(32) NOT NULL ,
	version_no           NUMBER(10) NOT NULL ,
	current_ind          CHAR(1) NULL ,
	cdd_update_date      DATE NOT NULL ,
	cdd_create_date      DATE NOT NULL ,
	cdd_rule_name        VARCHAR2(100) NOT NULL ,
	cdd_rule_description VARCHAR2(100) NOT NULL ,
	cdd_rule_status_code VARCHAR2(32) NOT NULL ,
	cdd_rule_type_code   VARCHAR2(32) NOT NULL ,
	cdd_rule_save_id_flg CHAR(1) NULL ,
	cdd_rule_order_in_group NUMBER(12) NOT NULL ,
	cdd_rule_group_id    VARCHAR2(32) NULL ,
	logical_delete_ind   CHAR(1) NULL ,
	create_user_id       VARCHAR2(60) NULL ,
	lstupdate_user_id    VARCHAR2(60) NULL 
)
	 TABLESPACE KC_DATA01;

CREATE UNIQUE INDEX FCFKC.XPKFSK_CDD_RULE ON FCFKC.FSK_CDD_RULE
(cdd_rule_id   ASC,version_no   ASC)
	TABLESPACE KC_INDEX01;

ALTER TABLE FCFKC.FSK_CDD_RULE
	ADD CONSTRAINT  XPKFSK_CDD_RULE PRIMARY KEY (cdd_rule_id,version_no);

CREATE  INDEX FCFKC.XIF1FSK_CDD_RULE ON FCFKC.FSK_CDD_RULE
(cdd_rule_group_id   ASC)
	TABLESPACE KC_INDEX01;

CREATE TABLE FCFKC.FSK_CDD_RULE_GROUP
(
	cdd_rule_group_id    VARCHAR2(32) NOT NULL ,
	version_no           NUMBER(10) NOT NULL ,
	current_ind          CHAR(1) NULL ,
	cdd_update_date      DATE NOT NULL ,
	cdd_create_date      DATE NOT NULL ,
	cdd_rule_group_file_name VARCHAR2(128) NULL ,
	cdd_rule_group_type  VARCHAR2(32) NOT NULL ,
	cdd_rule_group_category_code VARCHAR2(32) NULL ,
	cdd_rule_group_description VARCHAR2(100) NOT NULL ,
	cdd_rule_group_name  VARCHAR2(100) NOT NULL ,
	cdd_rule_group_input_ds_name VARCHAR2(32) NULL ,
	cdd_rule_group_by_var_1_name VARCHAR2(32) NULL ,
	cdd_rule_group_by_var_2_name VARCHAR2(32) NULL ,
	cdd_rule_group_level NUMBER(10) NULL ,
	cdd_rule_group_order_in_level NUMBER(10) NULL ,
	cdd_rule_group_save_to_kc_flg CHAR(1) NULL ,
	cdd_rule_group_save_trig_v_flg CHAR(1) NULL ,
	lstupdate_user_id    VARCHAR2(60) NULL ,
	logical_delete_ind   CHAR(1) NULL ,
	create_user_id       VARCHAR2(60) NULL 
)
	 TABLESPACE KC_DATA01;

CREATE UNIQUE INDEX FCFKC.XPKFSK_CDD_RULE_GROUP ON FCFKC.FSK_CDD_RULE_GROUP
(cdd_rule_group_id   ASC,version_no   ASC)
	TABLESPACE KC_INDEX01;

ALTER TABLE FCFKC.FSK_CDD_RULE_GROUP
	ADD CONSTRAINT  XPKFSK_CDD_RULE_GROUP PRIMARY KEY (cdd_rule_group_id,version_no);

CREATE TABLE FCFKC.FSK_CDD_RULE_PARAMETER
(
	cdd_rule_version_no  NUMBER(10) NOT NULL ,
	cdd_rule_parm_name   VARCHAR2(100) NOT NULL ,
	cdd_rule_id          VARCHAR2(32) NOT NULL ,
	cdd_rule_parm_description VARCHAR2(100) NOT NULL ,
	cdd_rule_parm_type_code VARCHAR2(32) NOT NULL ,
	cdd_rule_parm_val    VARCHAR2(1024) NOT NULL 
)
	 TABLESPACE KC_DATA01;

CREATE UNIQUE INDEX FCFKC.XPKFSK_CDD_RULE_PARAMETER ON FCFKC.FSK_CDD_RULE_PARAMETER
(cdd_rule_version_no   ASC,cdd_rule_parm_name   ASC,cdd_rule_id   ASC)
	TABLESPACE KC_INDEX01;

ALTER TABLE FCFKC.FSK_CDD_RULE_PARAMETER
	ADD CONSTRAINT  XPKFSK_CDD_RULE_PARAMETER PRIMARY KEY (cdd_rule_version_no,cdd_rule_parm_name,cdd_rule_id);

CREATE  INDEX FCFKC.XIF1FSK_CDD_RULE_PARAMETER ON FCFKC.FSK_CDD_RULE_PARAMETER
(cdd_rule_id   ASC);

CREATE TABLE FCFKC.FSK_CDD_SCORING_EVENT
(
	cdd_scoring_event_key NUMBER(12) NOT NULL ,
	primary_entity_key   NUMBER(12) NOT NULL ,
	primary_entity_number VARCHAR2(50) NOT NULL ,
	primary_entity_level_code CHAR(3) NOT NULL ,
	cdd_rule_id          VARCHAR2(32) NOT NULL ,
	version_no           NUMBER(10) NULL ,
	rule_score           NUMBER(10) NULL ,
	score_classification_code VARCHAR2(32) NULL ,
	event_date           DATE NOT NULL ,
	auto_high_ind        CHAR(1) NULL ,
	investigation_ind    CHAR(1) NULL ,
	category_code        VARCHAR2(32) NULL ,
	score_type_code      VARCHAR2(32) NULL 
)
	 TABLESPACE KC_DATA01;

CREATE UNIQUE INDEX FCFKC.XPKFSK_CDD_SCORING_EVENT ON FCFKC.FSK_CDD_SCORING_EVENT
(cdd_scoring_event_key   ASC)
	TABLESPACE KC_INDEX01;

ALTER TABLE FCFKC.FSK_CDD_SCORING_EVENT
	ADD CONSTRAINT  XPKFSK_CDD_SCORING_EVENT PRIMARY KEY (cdd_scoring_event_key);

CREATE UNIQUE INDEX FCFKC.XAK2FSK_CDD_SCORING_EVENT ON FCFKC.FSK_CDD_SCORING_EVENT
(cdd_rule_id   ASC,primary_entity_key   ASC,event_date   ASC)
	TABLESPACE KC_INDEX01;

CREATE  INDEX FCFKC.XIE2FSK_CDD_SCORING_EVENT ON FCFKC.FSK_CDD_SCORING_EVENT
(primary_entity_number   ASC)
	TABLESPACE KC_INDEX01;

CREATE  INDEX FCFKC.XIF1FSK_CDD_SCORING_EVENT ON FCFKC.FSK_CDD_SCORING_EVENT
(cdd_rule_id   ASC,version_no   ASC)
	TABLESPACE KC_INDEX01;


GRANT SELECT, INSERT, DELETE, UPDATE on FCFKC.FSK_CDD_RULE to FCFBU1;
GRANT SELECT, INSERT, DELETE, UPDATE on FCFKC.FSK_CDD_RULE_GROUP to FCFBU1;
GRANT SELECT, INSERT, DELETE, UPDATE on FCFKC.FSK_CDD_RULE_PARAMETER to FCFBU1;
GRANT SELECT, INSERT, DELETE, UPDATE on FCFKC.FSK_CDD_SCORING_EVENT to FCFBU1;



CREATE TABLE FCFKC.FSK_CDD_REVIEW
(
	review_key           NUMBER(12) NOT NULL ,
	version_number       NUMBER(10) NOT NULL ,
	primary_entity_number VARCHAR2(50) NOT NULL ,
	primary_entity_level_code CHAR(3) NOT NULL ,
	employee_ind         CHAR(1) NULL ,
	status_code          VARCHAR2(10) NULL ,
	owner_user_long_id   VARCHAR2(60) NULL ,
	initial_scoring_event_key NUMBER(12) NULL ,
	initial_risk_score   NUMBER(10) NULL ,
	initial_risk_rating  VARCHAR2(32) NULL ,
	initial_auto_high_ind CHAR(1) NULL ,
	periodic_review_date DATE NULL ,
	last_review_date     DATE NULL ,
	next_review_date     DATE NULL ,
	review_due_date      DATE NULL ,
	final_disposition_code VARCHAR2(32) NULL ,
	rating_override      VARCHAR2(32) NULL ,
	create_date          DATE NOT NULL ,
	create_user_id       VARCHAR2(60) NULL ,
	lstupdate_user_id    VARCHAR2(60) NULL ,
	lstupdate_date       DATE NOT NULL 
)
	 TABLESPACE KC_DATA01;

CREATE UNIQUE INDEX FCFKC.XPKFSK_CDD_REVIEW ON FCFKC.FSK_CDD_REVIEW
(review_key   ASC)
	TABLESPACE KC_INDEX01;

ALTER TABLE FCFKC.FSK_CDD_REVIEW
	ADD CONSTRAINT  XPKFSK_CDD_REVIEW PRIMARY KEY (review_key);

CREATE  INDEX FCFKC.XIE1FSK_CDD_REVIEW ON FCFKC.FSK_CDD_REVIEW
(primary_entity_number   ASC)
	TABLESPACE KC_INDEX01;

CREATE  INDEX FCFKC.XIE2FSK_CDD_REVIEW ON FCFKC.FSK_CDD_REVIEW
(primary_entity_level_code   ASC)
	TABLESPACE KC_INDEX01;

CREATE  INDEX FCFKC.XIE3FSK_CDD_REVIEW ON FCFKC.FSK_CDD_REVIEW
(owner_user_long_id   ASC)
	TABLESPACE KC_INDEX01;

CREATE  INDEX FCFKC.XIE4FSK_CDD_REVIEW ON FCFKC.FSK_CDD_REVIEW
(status_code   ASC)
	TABLESPACE KC_INDEX01;

CREATE  INDEX FCFKC.XIE5FSK_CDD_REVIEW ON FCFKC.FSK_CDD_REVIEW
(final_disposition_code   ASC)
	TABLESPACE KC_INDEX01;

CREATE TABLE FCFKC.FSK_CDD_REVIEW_EVENT
(
	event_id             NUMBER(12) NOT NULL ,
	event_type_code      VARCHAR(3) NOT NULL ,
	event_description    VARCHAR2(255) NULL ,
	create_user_id       VARCHAR2(60) NOT NULL ,
	create_date          DATE NOT NULL ,
	review_key           NUMBER(12) NOT NULL 
)
	 TABLESPACE KC_DATA01;

CREATE UNIQUE INDEX FCFKC.XPKFSK_CDD_REVIEW_EVENT ON FCFKC.FSK_CDD_REVIEW_EVENT
(event_id   ASC)
	TABLESPACE KC_INDEX01;

ALTER TABLE FCFKC.FSK_CDD_REVIEW_EVENT
	ADD CONSTRAINT  XPKFSK_CDD_REVIEW_EVENT PRIMARY KEY (event_id);

CREATE  INDEX FCFKC.XIF1FSK_CDD_REVIEW_EVENT ON FCFKC.FSK_CDD_REVIEW_EVENT
(review_key   ASC)
	TABLESPACE KC_INDEX01;

CREATE TABLE FCFKC.FSK_CDD_EDD_REVIEW
(
	review_key           NUMBER(12) NOT NULL ,
	edd_step_code        VARCHAR2(10) NOT NULL ,
	edd_step_sort_position_number INTEGER NULL ,
	edd_step_required    CHAR(1) NULL ,
	edd_step_completed   CHAR(1) NULL ,
	edd_step_notes       VARCHAR2(100) NULL 
)
	 TABLESPACE KC_DATA01;

CREATE UNIQUE INDEX FCFKC.XPKFSK_CDD_EDD_REVIEW ON FCFKC.FSK_CDD_EDD_REVIEW
(review_key   ASC,edd_step_code   ASC)
	TABLESPACE KC_INDEX01;

ALTER TABLE FCFKC.FSK_CDD_EDD_REVIEW
	ADD CONSTRAINT  XPKFSK_CDD_EDD_REVIEW PRIMARY KEY (review_key,edd_step_code);

CREATE  INDEX FCFKC.XIF1FSK_CDD_EDD_REVIEW ON FCFKC.FSK_CDD_EDD_REVIEW
(review_key   ASC)
	TABLESPACE KC_INDEX01;

ALTER TABLE FCFKC.FSK_CDD_REVIEW_EVENT
	ADD (CONSTRAINT FK_CDD_REVIEW_EVENT_CDD_REVIEW FOREIGN KEY (review_key) REFERENCES FCFKC.FSK_CDD_REVIEW (review_key));

ALTER TABLE FCFKC.FSK_CDD_EDD_REVIEW
	ADD (CONSTRAINT FK_CDD_EDD_REVIEW_CDD_REVIEW FOREIGN KEY (review_key) REFERENCES FCFKC.FSK_CDD_REVIEW (review_key));



GRANT SELECT, INSERT, DELETE, UPDATE on FCFKC.FSK_CDD_REVIEW to FCFBU1;

GRANT SELECT, INSERT, DELETE, UPDATE on FCFKC.FSK_CDD_REVIEW_EVENT to FCFBU1;

GRANT SELECT, INSERT, DELETE, UPDATE on FCFKC.FSK_CDD_EDD_REVIEW to FCFBU1;



ALTER TABLE FCFKC.FSK_RC_REPORT ADD SAR90_CASE_ID NUMBER(12)  NULL ;

ALTER TABLE FCFKC.FSK_CASE ADD  ACTIVATE_DATE TIMESTAMP NULL ;

ALTER TABLE FCFKC.FSK_RC_REPORT_ENTITY_INFO ADD ( 
	PARENT_ENTITY_NUMBER VARCHAR2(32) NULL,
	DEFAULT_IND CHAR(1) NULL
      );
      

ALTER TABLE FCFCORE.FSC_EXT_PARTY_ACCOUNT_DIM
ADD
   (
       change_begin_date    DATE DEFAULT  CURRENT_DATE NOT NULL,
       change_end_date      DATE DEFAULT  to_date('59990101','yyyymmdd') NOT NULL,
       change_current_ind   CHAR(1) DEFAULT 'Y' NOT NULL
   );



DROP VIEW FCFBU1.FSK_ALERT_TX_AGG CASCADE CONSTRAINTS;
DROP VIEW FCFBU1.FSK_ENTITY_TX_AGG CASCADE CONSTRAINTS;
DROP VIEW FCFBU1.FSK_ALERTED_ENTITY CASCADE CONSTRAINTS;
DROP VIEW FCFBU1.FSK_ENTITY_TRANSACTION CASCADE CONSTRAINTS;
DROP VIEW FCFBU1.FSK_ALERT_TRANSACTION CASCADE CONSTRAINTS;

DROP TABLE FCFKC.FSK_ENTITY_TX_AGG CASCADE CONSTRAINTS PURGE;
DROP TABLE FCFKC.FSK_ALERT_TX_AGG CASCADE CONSTRAINTS PURGE;
DROP TABLE FCFKC.FSK_ENTITY_TRANSACTION CASCADE CONSTRAINTS PURGE;
DROP TABLE FCFKC.FSK_ALERT_TRANSACTION CASCADE CONSTRAINTS PURGE;

DROP INDEX FCFKC.XAK1FSK_ALERTED_ENTITY;
ALTER TABLE FCFKC.FSK_ALERTED_ENTITY DROP CONSTRAINT XPKFSK_ALERTED_ENTITY;
DROP INDEX FCFKC.XPKFSK_ALERTED_ENTITY;
ALTER TABLE FCFKC.FSK_ALERTED_ENTITY DROP COLUMN alerted_entity_key;
ALTER TABLE FCFKC.FSK_ALERTED_ENTITY MODIFY alerted_entity_number VARCHAR2(50) NOT NULL;

CREATE UNIQUE INDEX FCFKC.XPKFSK_ALERTED_ENTITY ON FCFKC.FSK_ALERTED_ENTITY
(alerted_entity_level_code   ASC,alerted_entity_number   ASC)
	TABLESPACE KC_INDEX01;

ALTER TABLE FCFKC.FSK_ALERTED_ENTITY
	ADD CONSTRAINT  XPKFSK_ALERTED_ENTITY PRIMARY KEY (alerted_entity_level_code,alerted_entity_number);

CREATE UNIQUE INDEX FCFKC.XAK1FSK_ALERTED_ENTITY ON FCFKC.FSK_ALERTED_ENTITY
(alerted_entity_number   ASC,alerted_entity_level_code   ASC)
	TABLESPACE KC_INDEX01;

CREATE TABLE FCFKC.FSK_ALERT_TRANSACTION
(
	fsk_alert_transaction_pk NUMBER(22) NOT NULL ,
	alerted_entity_level_code CHAR(3) NULL ,
	alerted_entity_number VARCHAR2(50) NULL ,
	alert_id             NUMBER(12) NULL ,
	transaction_id       VARCHAR2(50) NULL ,
	transaction_amt      NUMERIC(15,3) NULL ,
	transaction_cdi_desc VARCHAR2(30) NULL ,
	primary_medium_desc  VARCHAR2(30) NULL ,
	secondary_medium_desc VARCHAR2(30) NULL ,
	transaction_date     TIMESTAMP NULL ,
	transaction_mechanism VARCHAR2(50) NULL ,
	account_number       VARCHAR2(50) NULL ,
	beneficiary_name     VARCHAR2(200) NULL ,
	associate_name       VARCHAR2(250) NULL ,
	Branch_name          VARCHAR2(100) NULL ,
	transaction_desc     VARCHAR2(255) NULL ,
	transaction_status   VARCHAR2(20) NULL ,
	triggering_indicator_cd VARCHAR2(3) NULL ,
	created_timestamp    TIMESTAMP NULL ,
	date_key             NUMBER(8) NULL ,
	time_key             NUMBER(6) NULL 
)
	 TABLESPACE KC_DATA01;

CREATE UNIQUE INDEX FCFKC.XPKFSK_ALERT_TRANSACTION ON FCFKC.FSK_ALERT_TRANSACTION
(fsk_alert_transaction_pk   ASC)
	TABLESPACE KC_INDEX01;

ALTER TABLE FCFKC.FSK_ALERT_TRANSACTION
	ADD CONSTRAINT  XPKFSK_ALERT_TRANSACTION PRIMARY KEY (fsk_alert_transaction_pk);

CREATE  INDEX FCFKC.XIF2FSK_ALERT_TRANSACTION ON FCFKC.FSK_ALERT_TRANSACTION
(alert_id   ASC)
	TABLESPACE KC_INDEX01;

CREATE  INDEX FCFKC.XIF3FSK_ALERT_TRANSACTION ON FCFKC.FSK_ALERT_TRANSACTION
(alerted_entity_level_code   ASC,alerted_entity_number   ASC)
	TABLESPACE KC_INDEX01;

CREATE TABLE FCFKC.FSK_ALERT_TX_AGG
(
	fsk_alert_tx_agg_pk  NUMBER(12) NOT NULL ,
	alert_id             NUMBER(12) NULL ,
	aggregate_type_code  VARCHAR2(35) NULL ,
	group_code           VARCHAR2(30) NULL ,
	group_desc           VARCHAR2(30) NULL ,
	aggregate_amt        NUMBER(15,3) NULL ,
	created_timestamp    TIMESTAMP NULL 
)
	 TABLESPACE KC_DATA01;

CREATE UNIQUE INDEX FCFKC.XPKFSK_ALERT_TX_AGG ON FCFKC.FSK_ALERT_TX_AGG
(fsk_alert_tx_agg_pk   ASC)
	TABLESPACE KC_INDEX01;

ALTER TABLE FCFKC.FSK_ALERT_TX_AGG
	ADD CONSTRAINT  XPKFSK_ALERT_TX_AGG PRIMARY KEY (fsk_alert_tx_agg_pk);

CREATE  INDEX FCFKC.XIF1FSK_ALERT_TX_AGG ON FCFKC.FSK_ALERT_TX_AGG
(alert_id   ASC)
	TABLESPACE KC_INDEX01;


CREATE TABLE FCFKC.FSK_ENTITY_TRANSACTION
(
	fsk_entity_transaction_pk NUMBER(22) NOT NULL ,
	alerted_entity_level_code CHAR(3) NULL ,
	alerted_entity_number VARCHAR2(50) NULL ,
	transaction_id       VARCHAR2(50) NULL ,
	transaction_amt      NUMERIC(15,3) NULL ,
	transaction_cdi_desc VARCHAR2(30) NULL ,
	primary_medium_desc  VARCHAR2(30) NULL ,
	secondary_medium_desc VARCHAR2(30) NULL ,
	transaction_date     TIMESTAMP NULL ,
	transaction_mechanism VARCHAR2(50) NULL ,
	account_number       VARCHAR2(50) NULL ,
	beneficiary_name     VARCHAR2(200) NULL ,
	associate_name       VARCHAR2(250) NULL ,
	Branch_name          VARCHAR2(100) NULL ,
	transaction_desc     VARCHAR2(255) NULL ,
	transaction_status   VARCHAR2(20) NULL ,
	created_timestamp    TIMESTAMP NULL ,
	date_key             NUMBER(8) NULL ,
	time_key             NUMBER(6) NULL ,
	household_number     VARCHAR2(50) NULL
)
	 TABLESPACE KC_DATA01;

CREATE UNIQUE INDEX FCFKC.XPKFSK_ENTITY_TRANSACTION ON FCFKC.FSK_ENTITY_TRANSACTION
(fsk_entity_transaction_pk   ASC)
	TABLESPACE KC_INDEX01;

ALTER TABLE FCFKC.FSK_ENTITY_TRANSACTION
	ADD CONSTRAINT  XPKFSK_ENTITY_TRANSACTION PRIMARY KEY (fsk_entity_transaction_pk);

CREATE  INDEX FCFKC.XIF1FSK_ENTITY_TRANSACTION ON FCFKC.FSK_ENTITY_TRANSACTION
(alerted_entity_level_code   ASC,alerted_entity_number   ASC)
	TABLESPACE KC_INDEX01;

CREATE TABLE FCFKC.FSK_ENTITY_TX_AGG
(
	fsk_entity_tx_agg_pk NUMBER(12) NOT NULL ,
	alerted_entity_level_code CHAR(3) NULL ,
	alerted_entity_number VARCHAR2(50) NULL ,
	aggregate_type_code  VARCHAR2(4) NULL ,
	group_code           VARCHAR2(50) NULL ,
	group_desc           VARCHAR2(50) NULL ,
	aggregate_amt        NUMBER(15,3) NULL ,
	created_timestamp    TIMESTAMP NULL 
)
	 TABLESPACE KC_DATA01;

CREATE UNIQUE INDEX FCFKC.XPKFSK_ENTITY_TX_AGG ON FCFKC.FSK_ENTITY_TX_AGG
(fsk_entity_tx_agg_pk   ASC);

ALTER TABLE FCFKC.FSK_ENTITY_TX_AGG
	ADD CONSTRAINT  XPKFSK_ENTITY_TX_AGG PRIMARY KEY (fsk_entity_tx_agg_pk);

CREATE  INDEX FCFKC.XIF1FSK_ENTITY_TX_AGG ON FCFKC.FSK_ENTITY_TX_AGG
(alerted_entity_level_code   ASC,alerted_entity_number   ASC)
	TABLESPACE KC_INDEX01;


GRANT SELECT, INSERT, DELETE, UPDATE on FCFKC.FSK_ALERT_TX_AGG  to FCFBU1;
GRANT SELECT, INSERT, DELETE, UPDATE on FCFKC.FSK_ENTITY_TX_AGG  to FCFBU1;
GRANT SELECT, INSERT, DELETE, UPDATE on FCFKC.FSK_ALERTED_ENTITY  to FCFBU1;
GRANT SELECT, INSERT, DELETE, UPDATE on FCFKC.FSK_ALERT_TRANSACTION  to FCFBU1;
GRANT SELECT, INSERT, DELETE, UPDATE on FCFKC.FSK_ENTITY_TRANSACTION  to FCFBU1;



ALTER TABLE FCFCORE.FSC_PARTY_DIM
ADD
   (
       ben_own_exempt_ind   CHAR(1) DEFAULT 'N' NULL
   );


ALTER TABLE FCFCORE.FSC_ACCOUNT_DIM
ADD
   (
       opened_by_party_number       VARCHAR2(50) NULL ,
       opened_by_party_name         VARCHAR2(200) NULL ,
       opened_by_party_title        VARCHAR2(50) NULL
   );

ALTER TABLE FCFKC.FSK_CASE
MODIFY
   (
       case_description VARCHAR2(100)
   );


CREATE TABLE FCFKC.FSK_SEGMENT (
  entity_segment_key  NUMBER(12) NOT NULL,
  entity_segment_id   NUMBER(12) NOT NULL,
  segment_name        VARCHAR2(50),
  segment_description VARCHAR2(100),
  lstupdate_user      VARCHAR2(60),
  logical_delete_ind  CHAR(1) DEFAULT 'N' NULL,
  active_ind          CHAR(1),
  change_begin_date   DATE DEFAULT CURRENT_DATE NOT NULL,
  change_end_date     DATE DEFAULT to_date('59990101','yyyymmdd') NOT NULL,
  change_current_ind  CHAR(1) DEFAULT 'Y' NOT NULL,
  CONSTRAINT XPKFSK_SEGMENT PRIMARY KEY (entity_segment_key)
) TABLESPACE KC_DATA01;

CREATE INDEX FCFKC.IDX_ID_FSK_SEGMENT ON FCFKC.FSK_SEGMENT (entity_segment_id) TABLESPACE KC_INDEX01;

GRANT REFERENCES ON FCFKC.FSK_SEGMENT TO FCFCORE;

ALTER TABLE FCFCORE.FSC_ACCOUNT_DIM   ADD entity_segment_id         NUMBER(12) NULL;
ALTER TABLE FCFCORE.FSC_PARTY_DIM     ADD entity_segment_id         NUMBER(12) NULL;
ALTER TABLE FCFKC.FSK_ALERT           ADD entity_segment_id         NUMBER(12) NULL;
ALTER TABLE FCFKC.FSK_ALERTED_ENTITY  ADD alerted_entity_segment_id NUMBER(12) NULL;
ALTER TABLE FCFKC.FSK_ALERTED_ENTITY  MODIFY alerted_entity_name    VARCHAR2(200);
ALTER TABLE FCFKC.FSK_ALERTED_ENTITY  DROP COLUMN owner_userid;

GRANT SELECT, INSERT, DELETE, UPDATE on FCFKC.FSK_SEGMENT to FCFBU1;


ALTER TABLE FCFKC.FSK_SCENARIO_PARAMETER DROP CONSTRAINT  PK_SCENARIO_PARAMETER;
DROP INDEX FCFKC.PK_SCENARIO_PARAMETER;
ALTER TABLE FCFKC.FSK_SCENARIO_PARAMETER
ADD
   (
       btl_parm_value      VARCHAR2(1024) NULL ,
       entity_segment_id   NUMBER(12) DEFAULT -1 NOT NULL
   );
CREATE UNIQUE INDEX FCFKC.PK_SCENARIO_PARAMETER ON FCFKC.FSK_SCENARIO_PARAMETER (scenario_id   ASC,parm_name   ASC, entity_segment_id ASC) 	TABLESPACE KC_INDEX01;
ALTER TABLE FCFKC.FSK_SCENARIO_PARAMETER ADD CONSTRAINT  PK_SCENARIO_PARAMETER PRIMARY KEY (scenario_id, parm_name, entity_segment_id);


ALTER TABLE FCFKC.FSK_SCENARIO
ADD
   (
       segments_enabled_ind CHAR(1) DEFAULT 'N' NULL,
       btl_enabled_ind      CHAR(1) DEFAULT 'N' NULL
   );


CREATE TABLE FCFKC.FSK_QUEUE (
  queue_key           NUMBER(12) NOT NULL,
  queue_code          VARCHAR2(32) NOT NULL,
  queue_description   VARCHAR2(100),
  access_role_name    VARCHAR2(60) NOT NULL,
  lstupdate_user      VARCHAR2(60),
  logical_delete_ind  CHAR(1) DEFAULT 'N' NULL,
  active_ind          CHAR(1),
  change_begin_date   DATE DEFAULT CURRENT_DATE NOT NULL,
  change_end_date     DATE DEFAULT to_date('59990101','yyyymmdd') NOT NULL,
  change_current_ind  CHAR(1) DEFAULT 'Y' NOT NULL,
  CONSTRAINT XPKFSK_QUEUE PRIMARY KEY (queue_key)
) TABLESPACE KC_DATA01;

CREATE INDEX FCFKC.IDX_ID_FSK_QUEUE ON FCFKC.FSK_QUEUE (queue_code) TABLESPACE KC_INDEX01;
GRANT SELECT, INSERT, DELETE, UPDATE on FCFKC.FSK_QUEUE to FCFBU1;

ALTER TABLE FCFKC.FSK_ALERT           ADD queue_code         VARCHAR2(32) NULL;
ALTER TABLE FCFKC.FSK_CASE            ADD queue_code         VARCHAR2(32) NULL;
ALTER TABLE FCFKC.FSK_CDD_REVIEW      ADD queue_code         VARCHAR2(32) NULL;
ALTER TABLE FCFKC.FSK_RC_REPORT       ADD queue_code         VARCHAR2(32) NULL;
ALTER TABLE FCFKC.FSK_RC_REPORT       ADD employee_ind  CHAR(1) DEFAULT 'N' NULL;

CREATE INDEX FCFKC.XEIQFSK_ALERT ON FCFKC.FSK_ALERT (queue_code) TABLESPACE KC_INDEX01;
CREATE INDEX FCFKC.XEIQFSK_CASE ON FCFKC.FSK_CASE (queue_code) TABLESPACE KC_INDEX01;
CREATE INDEX FCFKC.XEIQFSK_CDD_REVIEW ON FCFKC.FSK_CDD_REVIEW (queue_code) TABLESPACE KC_INDEX01;
CREATE INDEX FCFKC.XEIQFSK_RC_REPORT ON FCFKC.FSK_RC_REPORT (queue_code) TABLESPACE KC_INDEX01;




CREATE TABLE FCFKC.FSK_ENTITY_QUEUE (
  queue_code                VARCHAR2(32) NULL,
	alerted_entity_level_code CHAR(3) NOT NULL ,
	alerted_entity_number     VARCHAR2(50) NOT NULL,
	owner_userid              VARCHAR2(60) NULL
) TABLESPACE KC_DATA01;
GRANT SELECT, INSERT, DELETE, UPDATE on FCFKC.FSK_ENTITY_QUEUE to FCFBU1;

CREATE INDEX FCFKC.XEIQFSK_ENTITY_QUEUE ON FCFKC.FSK_ENTITY_QUEUE (alerted_entity_level_code, alerted_entity_number, queue_code, owner_userid) TABLESPACE KC_INDEX01;


ALTER TABLE FCFKC.FSK_CASE ADD case_close_date DATE NULL;


CREATE TABLE FCFKC.FSK_RC_REPORT_ENTITY_BRIDGE (
	report_key           NUMBER(12) NOT NULL ,
	parent_level_code    VARCHAR2(32) NOT NULL ,
	parent_key           NUMBER(12) NOT NULL ,
	entity_level_code    VARCHAR2(32) NOT NULL ,
	entity_key           NUMBER(12) NOT NULL ,
	ui_json              CLOB NULL ,
  CONSTRAINT XPKFSK_RPT_ENT_BR PRIMARY KEY (report_key, parent_key, entity_key)
) TABLESPACE KC_DATA01;

ALTER TABLE FCFKC.FSK_RC_REPORT_ENTITY_BRIDGE
	ADD (CONSTRAINT FSK_RC_ENT_BRIDGE_RPT FOREIGN KEY (report_key) REFERENCES FCFKC.FSK_RC_REPORT (report_key));

GRANT SELECT, INSERT, DELETE, UPDATE on FCFKC.FSK_RC_REPORT_ENTITY_BRIDGE to FCFBU1;


DROP INDEX FCFCORE.xtxthhd;
DROP INDEX FCFCORE.xtxtaccount;
DROP INDEX FCFCORE.xtxtparty;

ALTER TABLE FCFKC.FSK_ALERT MODIFY alerted_entity_name  VARCHAR2(200);
ALTER TABLE FCFKC.FSK_ALERT MODIFY primary_entity_name  VARCHAR2(200);
ALTER TABLE FCFKC.FSK_CASE_ENTITY MODIFY entity_name  VARCHAR2(200);
ALTER TABLE FCFKC.FSK_RC_REPORT_ENTITY MODIFY entity_name  VARCHAR2(200);
ALTER TABLE FCFKC.FSK_RC_REPORT_ENTITY_INFO MODIFY entity_name  VARCHAR2(200);

ALTER TABLE FCFCORE.FSC_BANK_DIM MODIFY bank_name  VARCHAR2(200);
ALTER TABLE FCFCORE.FSC_ASSOCIATE_DIM MODIFY associate_last_name  VARCHAR2(200);
ALTER TABLE FCFCORE.FSC_HOUSEHOLD_DIM MODIFY head_of_household_name VARCHAR(200);
ALTER TABLE FCFCORE.FSC_ACCOUNT_DIM MODIFY account_name VARCHAR(200);





DROP VIEW FCFBU1.FSK_INT_XFER;

DROP TABLE FCFKC.FSK_INT_XFER;

CREATE TABLE FCFKC.FSK_INT_XFER
(
    remitter_account_number VARCHAR2(304) NOT NULL ,
    remitter_name        VARCHAR2(304) NOT NULL ,
    remitter_party_key   NUMBER(12) NOT NULL ,
    beneficiary_account_number VARCHAR2(304) NOT NULL ,
    beneficiary_name     VARCHAR2(304) NOT NULL ,
    beneficiary_party_key NUMBER(12) NOT NULL ,
    date_key             NUMBER(8,0) NOT NULL ,
    time_key             NUMBER(6) NOT NULL ,
    currency_amount      NUMBER(18,5) NOT NULL ,
    edge_type_code       CHAR(4) NOT NULL
)
	 TABLESPACE KC_DATA01;

CREATE INDEX FCFKC.IDX_1_FSK_INT_XFER ON FCFKC.FSK_INT_XFER
( remitter_account_number ASC, beneficiary_account_number ASC )
	TABLESPACE KC_INDEX01;

GRANT SELECT, INSERT, DELETE, UPDATE on FCFKC.FSK_INT_XFER to FCFBU1;

ALTER TABLE FCFCORE.FSC_PARTY_DIM   ADD purge_date         DATE NULL;

CREATE OR REPLACE VIEW FCFBU1.FSK_ALERT AS SELECT * FROM FCFKC.FSK_ALERT;
CREATE OR REPLACE VIEW FCFBU1.FSK_CASE_ENTITY AS SELECT * FROM FCFKC.FSK_CASE_ENTITY;
CREATE OR REPLACE VIEW FCFBU1.FSK_RC_REPORT_ENTITY AS SELECT * from FCFKC.FSK_RC_REPORT_ENTITY;
CREATE OR REPLACE VIEW FCFBU1.FSK_RC_REPORT_ENTITY_INFO AS SELECT * FROM FCFKC.FSK_RC_REPORT_ENTITY_INFO;
CREATE OR REPLACE VIEW FCFBU1.FSC_BANK_DIM AS SELECT * FROM FCFCORE.FSC_BANK_DIM;
CREATE OR REPLACE VIEW FCFBU1.FSC_ASSOCIATE_DIM AS SELECT * FROM FCFCORE.FSC_ASSOCIATE_DIM;
CREATE OR REPLACE VIEW FCFBU1.FSC_HOUSEHOLD_DIM AS SELECT * FROM FCFCORE.FSC_HOUSEHOLD_DIM;
CREATE OR REPLACE VIEW FCFBU1.FSC_ACCOUNT_DIM AS SELECT * FROM FCFCORE.FSC_ACCOUNT_DIM;
CREATE OR REPLACE VIEW FCFBU1.FSK_INT_XFER AS SELECT * FROM FCFKC.FSK_INT_XFER;
CREATE OR REPLACE VIEW FCFBU1.FSC_PARTY_DIM AS SELECT * FROM FCFCORE.FSC_PARTY_DIM;
CREATE OR REPLACE VIEW FCFBU1.FSK_ALERT_TX_AGG AS SELECT * FROM FCFKC.FSK_ALERT_TX_AGG;
CREATE OR REPLACE VIEW FCFBU1.FSK_ENTITY_TX_AGG AS SELECT * FROM FCFKC.FSK_ENTITY_TX_AGG;
CREATE OR REPLACE VIEW FCFBU1.FSK_ALERT_TRANSACTION AS SELECT * FROM FCFKC.FSK_ALERT_TRANSACTION;
CREATE OR REPLACE VIEW FCFBU1.FSK_ENTITY_TRANSACTION AS SELECT * FROM FCFKC.FSK_ENTITY_TRANSACTION;
CREATE OR REPLACE VIEW FCFBU1.FSK_RC_REPORT_ENTITY_BRIDGE AS SELECT * FROM FCFKC.FSK_RC_REPORT_ENTITY_BRIDGE;
CREATE OR REPLACE VIEW FCFBU1.FSK_RC_FORM_CONFIG AS SELECT * FROM FCFKC.FSK_RC_FORM_CONFIG;
CREATE OR REPLACE VIEW FCFBU1.FSK_CDD_RULE AS SELECT * FROM FCFKC.FSK_CDD_RULE;
CREATE OR REPLACE VIEW FCFBU1.FSK_CDD_RULE_GROUP AS SELECT * FROM FCFKC.FSK_CDD_RULE_GROUP;
CREATE OR REPLACE VIEW FCFBU1.FSK_CDD_RULE_PARAMETER AS SELECT * FROM FCFKC.FSK_CDD_RULE_PARAMETER;
CREATE OR REPLACE VIEW FCFBU1.FSK_CDD_SCORING_EVENT AS SELECT * FROM FCFKC.FSK_CDD_SCORING_EVENT;
CREATE OR REPLACE VIEW FCFBU1.FSK_CDD_TRIGGERING_VALUES AS SELECT * FROM FCFKC.FSK_CDD_TRIGGERING_VALUES;
CREATE OR REPLACE VIEW FCFBU1.FSK_CDD_REVIEW AS SELECT * FROM FCFKC.FSK_CDD_REVIEW;
CREATE OR REPLACE VIEW FCFBU1.FSK_CDD_REVIEW_EVENT AS SELECT * FROM FCFKC.FSK_CDD_REVIEW_EVENT;
CREATE OR REPLACE VIEW FCFBU1.FSK_CDD_EDD_REVIEW AS SELECT * FROM FCFKC.FSK_CDD_EDD_REVIEW;
CREATE OR REPLACE VIEW FCFBU1.FSC_TRANSACTION_VIEW (account_key, account_number, branch_key, date_key, time_key, transaction_type_key, transaction_key,
currency_amount, transaction_reference_number, transaction_description, security_name, deal_number, bank_name_1, role_desc_1, bank_name_2,
role_desc_2, bank_name_3, role_desc_3, bank_name_4, role_desc_4, bank_name_5, role_desc_5, bank_name_6, role_desc_6) AS SELECT CFF.account_key,
ACC.account_number, CFF.branch_key, CFF.date_key, CFF.time_key, CFF.transaction_type_key, CFF.transaction_key, CFF.currency_amount, TD.transaction_reference_number,
TD.transaction_description, TD.security_name, TD.deal_number, BD.BANK_NAME AS bank_name_1, CFBB.Role_Desc AS role_desc_1, BD2.BANK_NAME AS bank_name_2,
 CFBB2.Role_Desc AS role_desc_2, BD3.BANK_NAME AS bank_name_3, CFBB3.Role_Desc AS role_desc_3, BD4.BANK_NAME AS bank_name_4, CFBB4.Role_Desc AS role_desc_4,
BD5.BANK_NAME AS bank_name_5, CFBB5.Role_Desc AS role_desc_5, BD6.BANK_NAME AS bank_name_6, CFBB6.Role_Desc AS role_desc_6
FROM FCFCORE.FSC_CASH_FLOW_FACT CFF JOIN FCFCORE.FSC_TRANSACTION_DIM TD ON CFF.transaction_key = TD.transaction_key
JOIN FCFCORE.FSC_ACCOUNT_DIM ACC ON CFF.account_key = ACC.account_key  LEFT JOIN FCFCORE.FSC_CASH_FLOW_BANK_BRIDGE CFBB
ON CFF.TRANSACTION_KEY = CFBB.TRANSACTION_KEY AND CFBB.SEQUENCE_NUMBER = 1 LEFT JOIN FCFCORE.FSC_BANK_DIM BD
ON CFBB.BANK_KEY = BD.BANK_KEY LEFT JOIN FCFCORE.FSC_CASH_FLOW_BANK_BRIDGE CFBB2 ON CFF.TRANSACTION_KEY = CFBB2.TRANSACTION_KEY
AND CFBB2.SEQUENCE_NUMBER = 2  LEFT JOIN FCFCORE.FSC_BANK_DIM BD2 ON CFBB2.BANK_KEY = BD2.BANK_KEY
LEFT JOIN FCFCORE.FSC_CASH_FLOW_BANK_BRIDGE CFBB3 ON CFF.TRANSACTION_KEY = CFBB3.TRANSACTION_KEY AND CFBB3.SEQUENCE_NUMBER = 3
LEFT JOIN FCFCORE.FSC_BANK_DIM BD3 ON CFBB3.BANK_KEY = BD3.BANK_KEY  LEFT JOIN FCFCORE.FSC_CASH_FLOW_BANK_BRIDGE CFBB4
ON CFF.TRANSACTION_KEY = CFBB4.TRANSACTION_KEY AND CFBB4.SEQUENCE_NUMBER = 4 LEFT JOIN FCFCORE.FSC_BANK_DIM BD4
ON CFBB4.BANK_KEY = BD4.BANK_KEY  LEFT JOIN FCFCORE.FSC_CASH_FLOW_BANK_BRIDGE CFBB5 ON CFF.TRANSACTION_KEY = CFBB5.TRANSACTION_KEY
AND CFBB5.SEQUENCE_NUMBER = 5  LEFT JOIN FCFCORE.FSC_BANK_DIM BD5 ON CFBB5.BANK_KEY = BD5.BANK_KEY
LEFT JOIN FCFCORE.FSC_CASH_FLOW_BANK_BRIDGE CFBB6 ON CFF.TRANSACTION_KEY = CFBB6.TRANSACTION_KEY AND CFBB6.SEQUENCE_NUMBER = 6
LEFT JOIN FCFCORE.FSC_BANK_DIM BD6 ON CFBB6.BANK_KEY = BD6.BANK_KEY
UNION ALL(SELECT AEF.account_key,
ACC.account_number, AEF.branch_key, AEF.date_key, AEF.time_key, AEF.transaction_type_key, AEF.transaction_key, 0, TD.transaction_reference_number, TD.transaction_description,
TD.security_name, TD.deal_number, '', '', '', '', '', '', '', '', '', '', '', '' FROM FCFCORE.FSC_ACCOUNT_EVENT_FACT AEF JOIN FCFCORE.FSC_ACCOUNT_DIM ACC
ON AEF.account_key = ACC.account_key  JOIN FCFCORE.FSC_TRANSACTION_DIM TD ON AEF.transaction_key = TD.transaction_key
UNION ALL
(SELECT ATF.account_key, ACC.account_number, ATF.branch_key, ATF.trade_date_key AS date_key,
ATF.execution_time_key AS time_key, ATF.transaction_type_key, ATF.transaction_key, ATF.principal_amount AS currency_amount, TD.transaction_reference_number,
TD.transaction_description, TD.security_name, TD.deal_number, '', '', '', '', '', '', '', '', '', '', '', '' FROM FCFCORE.FSC_ACCOUNT_TRADE_FACT ATF
JOIN FCFCORE.FSC_ACCOUNT_DIM ACC ON ATF.account_key = ACC.account_key  JOIN FCFCORE.FSC_TRANSACTION_DIM TD
ON ATF.transaction_key = TD.transaction_key));
CREATE OR REPLACE VIEW FCFBU1.FSK_RC_REPORT AS SELECT * FROM FCFKC.FSK_RC_REPORT;
CREATE OR REPLACE VIEW FCFBU1.FSK_CASE AS SELECT * FROM FCFKC.FSK_CASE;
CREATE OR REPLACE VIEW FCFBU1.FSC_EXT_PARTY_ACCOUNT_DIM AS SELECT * FROM FCFCORE.FSC_EXT_PARTY_ACCOUNT_DIM;
CREATE OR REPLACE VIEW FCFBU1.FSK_SEGMENT AS SELECT * FROM FCFKC.FSK_SEGMENT;
CREATE OR REPLACE VIEW FCFBU1.FSK_ALERTED_ENTITY AS SELECT * FROM FCFKC.FSK_ALERTED_ENTITY;
CREATE OR REPLACE VIEW FCFBU1.FSK_SCENARIO_PARAMETER AS SELECT * FROM FCFKC.FSK_SCENARIO_PARAMETER;
CREATE OR REPLACE VIEW FCFBU1.FSK_SCENARIO AS SELECT * FROM FCFKC.FSK_SCENARIO;
CREATE OR REPLACE VIEW FCFBU1.FSK_QUEUE AS SELECT * FROM FCFKC.FSK_QUEUE;
CREATE OR REPLACE VIEW FCFBU1.FSK_ENTITY_QUEUE AS SELECT * FROM FCFKC.FSK_ENTITY_QUEUE;
CREATE OR REPLACE VIEW FCFBU1.FSK_CASE AS SELECT * FROM FCFKC.FSK_CASE;

-- Change preference value lengths
ALTER TABLE FCFKC.FSK_PREFERENCE MODIFY (PREF_VALUE VARCHAR2(4000), PREF_VALUE_DEFAULT VARCHAR2(4000));
CREATE OR REPLACE VIEW FCFBU1.FSK_PREFERENCE AS SELECT * FROM FCFKC.FSK_PREFERENCE;

-- add lock columns to alerted entity
ALTER TABLE FCFKC.FSK_ALERTED_ENTITY ADD ( lock_userid VARCHAR2(32) NULL, lock_timestamp TIMESTAMP NULL);
CREATE OR REPLACE VIEW FCFBU1.FSK_ALERTED_ENTITY AS SELECT * FROM FCFKC.FSK_ALERTED_ENTITY;

-- add lock columns to report
ALTER TABLE FCFKC.FSK_RC_REPORT ADD ( lock_userid VARCHAR2(32) NULL, lock_timestamp TIMESTAMP NULL);
CREATE OR REPLACE VIEW FCFBU1.FSK_RC_REPORT AS SELECT * FROM FCFKC.FSK_RC_REPORT;

-- add lock columns to cdd review
ALTER TABLE FCFKC.FSK_CDD_REVIEW ADD ( lock_userid VARCHAR2(32) NULL, lock_timestamp TIMESTAMP NULL);
CREATE OR REPLACE VIEW FCFBU1.FSK_CDD_REVIEW AS SELECT * FROM FCFKC.FSK_CDD_REVIEW;

-- add lock columns to efile
ALTER TABLE FCFKC.FSK_RC_EFILE ADD ( lock_userid VARCHAR2(32) NULL, lock_timestamp TIMESTAMP NULL);
CREATE OR REPLACE VIEW FCFBU1.FSK_RC_EFILE AS SELECT * FROM FCFKC.FSK_RC_EFILE;

-- add lock columns to case
ALTER TABLE FCFKC.FSK_CASE ADD ( lock_userid VARCHAR2(32) NULL, lock_timestamp TIMESTAMP NULL);
CREATE OR REPLACE VIEW FCFBU1.FSK_CASE AS SELECT * FROM FCFKC.FSK_CASE;

-- add update info columns to alerted entity
ALTER TABLE FCFKC.FSK_ALERTED_ENTITY ADD ( LSTUPDATE_USER_ID VARCHAR2(32) NULL, LSTUPDATE_DATE TIMESTAMP NULL);
CREATE OR REPLACE VIEW FCFBU1.FSK_ALERTED_ENTITY AS SELECT * FROM FCFKC.FSK_ALERTED_ENTITY;

-- add efile event table
CREATE TABLE FCFKC.FSK_RC_EFILE_EVENT
(
	event_id             NUMBER(12) NOT NULL ,
	efile_key           NUMBER(12) NOT NULL ,
	event_type_code      VARCHAR(3) NOT NULL ,
	event_description    VARCHAR2(255) NULL ,
	create_user_id       VARCHAR2(60) NOT NULL ,
	create_date          DATE NOT NULL
)
	 TABLESPACE KC_DATA01;

CREATE UNIQUE INDEX FCFKC.XPKFSK_RC_EFILE_EVENT ON FCFKC.FSK_RC_EFILE_EVENT (event_id   ASC)
	TABLESPACE KC_INDEX01;

ALTER TABLE FCFKC.FSK_RC_EFILE_EVENT
	ADD CONSTRAINT  XPKFSK_RC_EFILE_EVENT PRIMARY KEY (event_id);

CREATE  INDEX FCFKC.XIF1FSK_RC_EFILE_EVENT ON FCFKC.FSK_RC_EFILE_EVENT (efile_key   ASC)
	TABLESPACE KC_INDEX01;

ALTER TABLE FCFKC.FSK_RC_EFILE_EVENT
	ADD (CONSTRAINT FK_EFILE_EVENT_EFILE FOREIGN KEY (efile_key) REFERENCES FCFKC.FSK_RC_EFILE (efile_key));

GRANT SELECT, INSERT, DELETE, UPDATE on FCFKC.FSK_RC_EFILE_EVENT to FCFBU1;
CREATE OR REPLACE VIEW FCFBU1.FSK_RC_EFILE_EVENT AS SELECT * FROM FCFKC.FSK_RC_EFILE_EVENT;
