-- Added columns
ALTER TABLE FCFCORE.FSC_PARTY_DIM   ADD purge_date         DATE NULL;

-- Replace/create views of altered/created tables
CREATE OR REPLACE VIEW FCFBU1.FSC_PARTY_DIM AS SELECT * FROM FCFCORE.FSC_PARTY_DIM;

-- Change preference value lengths
ALTER TABLE FCFKC.FSK_PREFERENCE MODIFY (PREF_VALUE VARCHAR2(4000), PREF_VALUE_DEFAULT VARCHAR2(4000));
CREATE OR REPLACE VIEW FCFBU1.FSK_PREFERENCE AS SELECT * FROM FCFKC.FSK_PREFERENCE;

-- add lock columns to alerted entity
ALTER TABLE FCFKC.FSK_ALERTED_ENTITY ADD ( lock_userid VARCHAR2(32) NULL, lock_timestamp TIMESTAMP NULL);
CREATE OR REPLACE VIEW FCFBU1.FSK_ALERTED_ENTITY AS SELECT * FROM FCFKC.FSK_ALERTED_ENTITY;

-- add lock columns to report
ALTER TABLE FCFKC.FSK_RC_REPORT ADD ( lock_userid VARCHAR2(32) NULL, lock_timestamp TIMESTAMP NULL);
CREATE OR REPLACE VIEW FCFBU1.FSK_RC_REPORT AS SELECT * FROM FCFKC.FSK_RC_REPORT;

-- add lock columns to cdd review
ALTER TABLE FCFKC.FSK_CDD_REVIEW ADD ( lock_userid VARCHAR2(32) NULL, lock_timestamp TIMESTAMP NULL);
CREATE OR REPLACE VIEW FCFBU1.FSK_CDD_REVIEW AS SELECT * FROM FCFKC.FSK_CDD_REVIEW;

-- add lock columns to efile
ALTER TABLE FCFKC.FSK_RC_EFILE ADD ( lock_userid VARCHAR2(32) NULL, lock_timestamp TIMESTAMP NULL);
CREATE OR REPLACE VIEW FCFBU1.FSK_RC_EFILE AS SELECT * FROM FCFKC.FSK_RC_EFILE;

-- add lock columns to case
ALTER TABLE FCFKC.FSK_CASE ADD ( lock_userid VARCHAR2(32) NULL, lock_timestamp TIMESTAMP NULL);
CREATE OR REPLACE VIEW FCFBU1.FSK_CASE AS SELECT * FROM FCFKC.FSK_CASE;

-- add update info columns to alerted entity
ALTER TABLE FCFKC.FSK_ALERTED_ENTITY ADD ( LSTUPDATE_USER_ID VARCHAR2(32) NULL, LSTUPDATE_DATE TIMESTAMP NULL);
CREATE OR REPLACE VIEW FCFBU1.FSK_ALERTED_ENTITY AS SELECT * FROM FCFKC.FSK_ALERTED_ENTITY;

-- add efile event table
CREATE TABLE FCFKC.FSK_RC_EFILE_EVENT
(
	event_id             NUMBER(12) NOT NULL ,
	efile_key           NUMBER(12) NOT NULL ,
	event_type_code      VARCHAR(3) NOT NULL ,
	event_description    VARCHAR2(255) NULL ,
	create_user_id       VARCHAR2(60) NOT NULL ,
	create_date          DATE NOT NULL
)
	 TABLESPACE KC_DATA01;

CREATE UNIQUE INDEX FCFKC.XPKFSK_RC_EFILE_EVENT ON FCFKC.FSK_RC_EFILE_EVENT (event_id   ASC)
	TABLESPACE KC_INDEX01;

ALTER TABLE FCFKC.FSK_RC_EFILE_EVENT
	ADD CONSTRAINT  XPKFSK_RC_EFILE_EVENT PRIMARY KEY (event_id);

CREATE  INDEX FCFKC.XIF1FSK_RC_EFILE_EVENT ON FCFKC.FSK_RC_EFILE_EVENT (efile_key   ASC)
	TABLESPACE KC_INDEX01;

ALTER TABLE FCFKC.FSK_RC_EFILE_EVENT
	ADD (CONSTRAINT FK_EFILE_EVENT_EFILE FOREIGN KEY (efile_key) REFERENCES FCFKC.FSK_RC_EFILE (efile_key));

GRANT SELECT, INSERT, DELETE, UPDATE on FCFKC.FSK_RC_EFILE_EVENT to FCFBU1;
CREATE OR REPLACE VIEW FCFBU1.FSK_RC_EFILE_EVENT AS SELECT * FROM FCFKC.FSK_RC_EFILE_EVENT;