--------------------------------------------------------------
--------------------------------------------------------------
-- Scripts to update the object ID on attachments in
-- FSK_ATTACHMENT before HF4
--------------------------------------------------------------
--
-- Prior to HF4 the object id for EXT entities was the entity key
-- Post HF4 it is the entity number
--
-- The date in the where clause must be set to the date when
-- the hot fix was applied
--
--------------------------------------------------------------
--------------------------------------------------------------

USE [LOCALDB]
GO

update SCHKC.fsk_attachment set object_id =
       (select external_party_number from SCHCORE.fsc_ext_party_account_dim
        where SCHKC.fsk_comment.object_id = cast(SCHCORE.fsc_ext_party_account_dim.ext_party_account_key as char))
where   SCHKC.fsk_comment.object_type_cd = 'EXT' and
        SCHKC.fsk_comment.create_date < {ts'2001-06-23 19:52:00'} -- date of applying HF4
GO