REPLACE VIEW FCFBU1.FSK_SEQ AS LOCK ROW FOR ACCESS SELECT next_sequence_id FROM FCFKC.FSK_SEQ;

-- Update FSK_RC_FORM_CONFIG

ALTER TABLE FCFKC.FSK_RC_FORM_CONFIG
     ADD  IMPLEMENTATION_TYPE_CODE VARCHAR(32) NULL ;
     
DROP VIEW FCFBU1.FSK_RC_FORM_CONFIG;

CREATE VIEW FCFBU1.FSK_RC_FORM_CONFIG AS SELECT * FROM FCFKC.FSK_RC_FORM_CONFIG; 


-- Recreate CDD Rule Tables


DROP VIEW FCFBU1.FSK_CDD_RULE;

DROP VIEW FCFBU1.FSK_CDD_RULE_PARAMETER;

DROP VIEW FCFBU1.FSK_CDD_RULE_GROUP;

DROP VIEW FCFBU1.FSK_CDD_SCORING_EVENT;

DROP VIEW FCFBU1.FSK_CDD_TRIGGERING_VALUES;

DROP TABLE FCFKC.FSK_CDD_RULE_PARAMETER;

DROP TABLE FCFKC.FSK_CDD_RULE;

DROP TABLE FCFKC.FSK_CDD_RULE_GROUP;

DROP TABLE FCFKC.FSK_CDD_SCORING_EVENT;


CREATE SET TABLE FCFKC.FSK_CDD_RULE,
	 NO FALLBACK, 
	 NO BEFORE JOURNAL, 
	 NO AFTER JOURNAL, 
	 CHECKSUM = DEFAULT
(
	cdd_rule_id          VARCHAR(32) NOT NULL ,
	version_no           DECIMAL(10) NOT NULL ,
	current_ind          CHAR(1)  ,
	cdd_update_date      TIMESTAMP(6) NOT NULL ,
	cdd_create_date      TIMESTAMP(6) NOT NULL ,
	cdd_rule_name        VARCHAR(100) NOT NULL ,
	cdd_rule_description VARCHAR(100) NOT NULL ,
	cdd_rule_status_code VARCHAR(32) NOT NULL ,
	cdd_rule_type_code   VARCHAR(32) NOT NULL ,
	cdd_rule_save_id_flg CHAR(1)  ,
	cdd_rule_order_in_group DECIMAL(12) NOT NULL ,
	cdd_rule_group_id    VARCHAR(32)  ,
	logical_delete_ind   CHAR(1)  ,
	create_user_id       VARCHAR(60)  ,
	lstupdate_user_id    VARCHAR(60)  
)
	UNIQUE PRIMARY INDEX XPKFSK_CDD_RULE(cdd_rule_id,version_no);

CREATE  INDEX XIF1FSK_CDD_RULE(cdd_rule_group_id) ON FCFKC.FSK_CDD_RULE;

CREATE SET TABLE FCFKC.FSK_CDD_RULE_GROUP,
	 NO FALLBACK, 
	 NO BEFORE JOURNAL, 
	 NO AFTER JOURNAL, 
	 CHECKSUM = DEFAULT
(
	cdd_rule_group_id    VARCHAR(32) NOT NULL ,
	version_no           DECIMAL(10) NOT NULL ,
	current_ind          CHAR(1)  ,
	cdd_update_date      TIMESTAMP(6) NOT NULL ,
	cdd_create_date      TIMESTAMP(6) NOT NULL ,
	cdd_rule_group_file_name VARCHAR(128)  ,
	cdd_rule_group_type  VARCHAR(32) NOT NULL ,
	cdd_rule_group_category_code VARCHAR(32)  ,
	cdd_rule_group_description VARCHAR(100) NOT NULL ,
	cdd_rule_group_name  VARCHAR(100) NOT NULL ,
	cdd_rule_group_input_ds_name VARCHAR(32)  ,
	cdd_rule_group_by_var_1_name VARCHAR(32)  ,
	cdd_rule_group_by_var_2_name VARCHAR(32)  ,
	cdd_rule_group_level DECIMAL(10)  ,
	cdd_rule_group_order_in_level DECIMAL(10)  ,
	cdd_rule_group_save_to_kc_flg CHAR(1)  ,
	cdd_rule_group_save_trig_v_flg CHAR(1)  ,
	lstupdate_user_id    VARCHAR(60)  ,
	logical_delete_ind   CHAR(1)  ,
	create_user_id       VARCHAR(60)  
)
	UNIQUE PRIMARY INDEX XPKFSK_CDD_RULE_GROUP(cdd_rule_group_id,version_no);

CREATE SET TABLE FCFKC.FSK_CDD_RULE_PARAMETER,
	 NO FALLBACK, 
	 NO BEFORE JOURNAL, 
	 NO AFTER JOURNAL, 
	 CHECKSUM = DEFAULT
(
	cdd_rule_version_no  DECIMAL(10) NOT NULL ,
	cdd_rule_parm_name   VARCHAR(100) NOT NULL ,
	cdd_rule_id          VARCHAR(32) NOT NULL ,
	cdd_rule_parm_description VARCHAR(100) NOT NULL ,
	cdd_rule_parm_type_code VARCHAR(32) NOT NULL ,
	cdd_rule_parm_val    VARCHAR(1024) NOT NULL 
)
	UNIQUE PRIMARY INDEX XPKFSK_CDD_RULE_PARAMETER(cdd_rule_version_no,cdd_rule_parm_name,cdd_rule_id);

CREATE  INDEX XIF1FSK_CDD_RULE_PARAMETER(cdd_rule_id) ON FCFKC.FSK_CDD_RULE_PARAMETER;


CREATE SET TABLE FCFKC.FSK_CDD_SCORING_EVENT,
	 NO FALLBACK, 
	 NO BEFORE JOURNAL, 
	 NO AFTER JOURNAL, 
	 CHECKSUM = DEFAULT
(
	cdd_scoring_event_key DECIMAL(12) NOT NULL ,
	primary_entity_key   DECIMAL(12) NOT NULL ,
	primary_entity_number VARCHAR(50) NOT NULL ,
	primary_entity_level_code CHAR(3) NOT NULL ,
	cdd_rule_id          VARCHAR(32) NOT NULL ,
	version_no           DECIMAL(10)  ,
	rule_score           DECIMAL(10)  ,
	score_classification_code VARCHAR(32)  ,
	event_date           TIMESTAMP(6) NOT NULL ,
	auto_high_ind        CHAR(1)  ,
	investigation_ind    CHAR(1)  ,
	category_code        VARCHAR(32)  ,
	score_type_code      VARCHAR(32)  
)
	UNIQUE PRIMARY INDEX XPKFSK_CDD_SCORING_EVENT(cdd_scoring_event_key);

CREATE  UNIQUE  INDEX XAK2FSK_CDD_SCORING_EVENT(cdd_rule_id, primary_entity_key, event_date) ON FCFKC.FSK_CDD_SCORING_EVENT;

CREATE  INDEX XIE2FSK_CDD_SCORING_EVENT(primary_entity_number) ON FCFKC.FSK_CDD_SCORING_EVENT;

CREATE  INDEX XIF1FSK_CDD_SCORING_EVENT(cdd_rule_id, version_no) ON FCFKC.FSK_CDD_SCORING_EVENT;


CREATE VIEW FCFBU1.FSK_CDD_RULE AS SELECT * FROM FCFKC.FSK_CDD_RULE;

CREATE VIEW FCFBU1.FSK_CDD_RULE_GROUP AS SELECT * FROM FCFKC.FSK_CDD_RULE_GROUP;

CREATE VIEW FCFBU1.FSK_CDD_RULE_PARAMETER AS SELECT * FROM FCFKC.FSK_CDD_RULE_PARAMETER;

CREATE VIEW FCFBU1.FSK_CDD_SCORING_EVENT AS SELECT * FROM FCFKC.FSK_CDD_SCORING_EVENT;

-- Update existing CDD views

CREATE VIEW FCFBU1.FSK_CDD_TRIGGERING_VALUES AS SELECT * FROM FCFKC.FSK_CDD_TRIGGERING_VALUES;




-- Add CDD Review Tables


CREATE SET TABLE FCFKC.FSK_CDD_REVIEW,
	 NO FALLBACK, 
	 NO BEFORE JOURNAL, 
	 NO AFTER JOURNAL, 
	 CHECKSUM = DEFAULT
(
	review_key           DECIMAL(12) NOT NULL ,
	version_number       DECIMAL(10) NOT NULL ,
	primary_entity_number VARCHAR(50) NOT NULL ,
	primary_entity_level_code CHAR(3) NOT NULL ,
	employee_ind         CHAR(1)  ,
	status_code          VARCHAR(10)  ,
	owner_user_long_id   VARCHAR(60)  ,
	initial_scoring_event_key DECIMAL(12)  ,
	initial_risk_score   DECIMAL(10)  ,
	initial_risk_rating  VARCHAR(32)  ,
	initial_auto_high_ind CHAR(1)  ,
	periodic_review_date TIMESTAMP(6)  ,
	last_review_date     TIMESTAMP(6)  ,
	next_review_date     TIMESTAMP(6)  ,
	review_due_date      TIMESTAMP(6)  ,
	final_disposition_code VARCHAR(32)  ,
	rating_override      VARCHAR(32)  ,
	create_date          TIMESTAMP(6) NOT NULL ,
	create_user_id       VARCHAR(60)  ,
	lstupdate_user_id    VARCHAR(60)  ,
	lstupdate_date       TIMESTAMP(6) NOT NULL 
)
	UNIQUE PRIMARY INDEX XPKFSK_CDD_REVIEW(review_key);

CREATE  INDEX XIE1FSK_CDD_REVIEW(primary_entity_number) ON FCFKC.FSK_CDD_REVIEW;

CREATE  INDEX XIE2FSK_CDD_REVIEW(primary_entity_level_code) ON FCFKC.FSK_CDD_REVIEW;

CREATE  INDEX XIE3FSK_CDD_REVIEW(owner_user_long_id) ON FCFKC.FSK_CDD_REVIEW;

CREATE  INDEX XIE4FSK_CDD_REVIEW(status_code) ON FCFKC.FSK_CDD_REVIEW;

CREATE  INDEX XIE5FSK_CDD_REVIEW(final_disposition_code) ON FCFKC.FSK_CDD_REVIEW;

CREATE SET TABLE FCFKC.FSK_CDD_REVIEW_EVENT,
	 NO FALLBACK, 
	 NO BEFORE JOURNAL, 
	 NO AFTER JOURNAL, 
	 CHECKSUM = DEFAULT
(
	event_id             DECIMAL(12) NOT NULL ,
	event_type_code      VARCHAR(3) NOT NULL ,
	event_description    VARCHAR(255)  ,
	create_user_id       VARCHAR(60) NOT NULL ,
	create_date          TIMESTAMP(6) NOT NULL ,
	review_key           DECIMAL(12) NOT NULL 
)
	UNIQUE PRIMARY INDEX XPKFSK_CDD_REVIEW_EVENT(event_id);

CREATE  INDEX XIF1FSK_CDD_REVIEW_EVENT(review_key) ON FCFKC.FSK_CDD_REVIEW_EVENT;

CREATE SET TABLE FCFKC.FSK_CDD_EDD_REVIEW,
	 NO FALLBACK, 
	 NO BEFORE JOURNAL, 
	 NO AFTER JOURNAL, 
	 CHECKSUM = DEFAULT
(
	review_key           DECIMAL(12) NOT NULL ,
	edd_step_code        VARCHAR(10) NOT NULL ,
	edd_step_sort_position_number INTEGER  ,
	edd_step_required    CHAR(1)  ,
	edd_step_completed   CHAR(1)  ,
	edd_step_notes       VARCHAR(100)  
)
	UNIQUE PRIMARY INDEX XPKFSK_CDD_EDD_REVIEW(review_key,edd_step_code);

CREATE  INDEX XIF1FSK_CDD_EDD_REVIEW(review_key) ON FCFKC.FSK_CDD_EDD_REVIEW;



CREATE VIEW FCFBU1.FSK_CDD_REVIEW AS SELECT * FROM FCFKC.FSK_CDD_REVIEW;

CREATE VIEW FCFBU1.FSK_CDD_EDD_REVIEW AS SELECT * FROM FCFKC.FSK_CDD_EDD_REVIEW;

CREATE VIEW FCFBU1.FSK_CDD_REVIEW_EVENT AS SELECT * FROM FCFKC.FSK_CDD_REVIEW_EVENT;
