%macro  rc_efile_gen_json_schema(form_config_key=
                          , form_type_code=                         
               ) /  des='Macro to create json schema';         

  
proc sql noprint; 
    create table rc_field_def as
    select a.form_efile_field_seq_number,
            case 
                when (index(a.source_field_name,'.') > 0) then scan(a.source_field_name,2,'.') 
                else a.source_field_name
            end as source_field_name length=64,
           a.target_field_name,
           a.target_field_length, 
           a.source_field_type ,
           a.source_field_type_parm_list,
           index(a.target_field_desc,'REQUIRED') as required ,
           a.target_field_num_flg,
           case
               when (index(a.source_field_name,'.') > 0) then upcase(scan(a.source_field_name,1,'.')) 
               else b.source_entity_level_code
               end as source_entity_level_code length=32,
           b.source_group_name 
    from rc_cfg.form_efile_field_config(%fcf_get_ds_opts(lib_name=rc_cfg, ds_name=form_efile_field_config)) as a
    left join   rc_cfg.form_efile_record_config(%fcf_get_ds_opts(lib_name=rc_cfg, ds_name=form_efile_record_config)) as b
    on a.form_config_key=b.form_config_key 
       and a.form_efile_record_seq_number=b.form_efile_record_seq_number
     where   a.form_config_key=&form_config_key 
             and source_table_name='RC_REPORT_NODE' and source_field_name ne ''
             and upcase(source_field_name) ne source_field_name

    order by source_entity_level_code, source_group_name,  form_efile_field_seq_number 


   ;
   quit;

data rc_field_def_adj;
    set rc_field_def;
    length type format $ 32;

    select (source_field_type);


   
     when ('BOOLEAN') 
     do;
          type='boolean';
          output;
     end;
     when ('DATE')  
     do;
         type='string';
         format='date-time';
         output;
     end;
     when ('ARRYCAT')
     do;
         orig_source_field_name=source_field_name;
         do iascii=rank(strip(scan(source_field_type_parm_list,1,','))) to 
                    rank(strip(scan(source_field_type_parm_list,2,','))) ;
 
             source_field_name=strip(orig_source_field_name)||byte(iascii);
             type='boolean';
             output;
         end;
         if index(source_field_type_parm_list,'Z') then 
         do;
            source_field_name=strip(orig_source_field_name)||'Z';
            type='boolean';
            output;
         end;

 
     end;
     otherwise
     do;          
       if target_field_num_flg='1' then type='integer';
       else 
       do;
            type='string';
            maxlength=target_field_length;
            
       end;
       output;
       end;
    end;
 run;
  
        
data _null_;
   file rc_tmplt(&form_type_code._json_schema.json);
   length stmt $256;
   set rc_field_def_adj;
   by source_entity_level_code source_group_name ;
   if first.source_entity_level_code then link entity_header;
   if first.source_group_name then link group_header;
   if first.source_group_name then
      stmt='  "'||strip(source_field_name)||'":{';
    else 
      stmt=', "'||strip(source_field_name)||'":{';
    
   stmt=trim(stmt)||'"type":"'||strip(type)||'"';
  
   if format ne '' then 
   do;
      stmt=trim(stmt)||', "format":"'||strip(format)||'"';
      
   end;
   if maxlength > 0 then 
   do;
      stmt=trim(stmt)||', "maxLength":"'||strip(put(maxLength,best.))||'"';
     
   end;
   stmt=trim(stmt)||'}';   
   put stmt $char.;
   if last.source_group_name then link group_trailer;
   if last.source_entity_level_code then link entity_trailer;
   return;
 
entity_header:

stmt='{"'||strip(source_entity_level_code)||'":{';
put stmt;
return;
entity_trailer:
stmt='}}';
put stmt;
return;
group_header:
if source_group_name ne '' then
do;
stmt=', "'||strip(source_group_name)||'":[{';
put stmt;
end;
return;
group_trailer:
if source_group_name ne '' then
do;
stmt='}]';
put stmt;
end;
return;

run; 

%mend;

