

%macro rc_efile_gen_sasddl(form_config_key=,ddlfref=ddlpath,outlib=rc_db,form_type_code=);

 

 
data _null_;
     set rc_cfg.form_efile_field_config(%fcf_get_ds_opts(lib_name=rc_cfg, ds_name=form_efile_field_config));
     by form_efile_record_seq_number;
     where form_config_key=&form_config_key and
           target_field_name not in ('FILLER' 'REPORT_KEY' 'EFILE_KEY' 'REPORT_SEQUENCE_NUMBER');
     length stmt $ 4096; 
    
     file &ddlfref("%trim(&form_type_code)_ddl.sas");
     if first.form_efile_record_seq_number then link wrt_header;
     link wrt_field;
     if last.form_efile_record_seq_number then link wrt_trailer;
     return;

WRT_HEADER:
 
        stmt='DATA '||"%upcase(&outlib).%trim(&form_type_code)_"||strip(form_efile_record_id)
              ||' (%fcf_get_ds_opts(lib_name=' || "&outlib, ds_name=%trim(&form_type_code)_"||strip(form_efile_record_id)
              || ', output_ds=Y) index=(report_key)) '
              ||';';
        put stmt;
       
        stmt='attrib EFILE_KEY length=8 label="E-File Key";';
        put stmt;       
        stmt='attrib REPORT_KEY length=8 label="Report Key";';
        put stmt;
        stmt='attrib ENTITY_KEY length=8 label="Entity Key";';
        put stmt;
        stmt='attrib ENTITY_LEVEL_CODE length=$32 label="Entity Level Code";';
        put stmt;
        stmt='attrib NODE_PATH length=$128 label="Node Path";';
        put stmt;
        stmt='attrib REPORT_SEQ_NUMBER length=8 label="Report Sequence Number";';
        put stmt;
        stmt='attrib ENTITY_SEQ_NUMBER length=8 label="Entity Sequence Number";';
        put stmt;
        stmt='attrib ROW_SEQ_NUMBER length=8 label="Row Sequence Number";';
        put stmt;
         
return;

WRT_field:  
    
    if target_field_name  ne ''  then  
    do;
       stmt='attrib '|| strip(target_field_name);
       if target_field_num_flg='1' then stmt=strip(stmt)||' length=8';
       else  stmt=strip(stmt)||' length=$'||strip(put(target_field_length,best.));
       stmt=strip(stmt)||' label='||quote(strip(target_field_short_desc));
      
       if target_sas_format_name > '' then stmt=strip(stmt)||' format='||strip(target_sas_format_name);
       stmt=strip(stmt)||';';
       put stmt;
    end;
    
return;

WRT_TRAILER:
    
          stmt='stop; run;';
          put stmt;
          put;
return;

    
run;

%mend;

 
